if not GroupAIStateBase or not UnitNetworkHandler then
    return
end

local GroupAIStateBase_convert_hostage_to_criminal_original = GroupAIStateBase.convert_hostage_to_criminal

function GroupAIStateBase:convert_hostage_to_criminal(unit, ...)
    GroupAIStateBase_convert_hostage_to_criminal_original(self, unit, ...)
    
    if alive(unit) then
        local player_unit = managers.player:player_unit()
        local minion_owner_peer_id = managers.criminals:character_color_id_by_unit(player_unit)
        local color = tweak_data.peer_vector_colors[minion_owner_peer_id]
        
        unit:contour():change_color("friendly", color)
    end
end

local UnitNetworkHandler_mark_minion_original = UnitNetworkHandler.mark_minion

function UnitNetworkHandler:mark_minion(unit, minion_owner_peer_id, ...)
    UnitNetworkHandler_mark_minion_original(self, unit, minion_owner_peer_id, ...)
    
    if alive(unit) then
        local color = tweak_data.peer_vector_colors[minion_owner_peer_id]
        
        unit:contour():change_color("friendly", color)
	end
end